          #include <P16F628A.INC>
            LIST        p=16F628A     
            __CONFIG    H'3F10'             ; 
                                     
            
Sec           equ         0020h             ;    
Sec1          equ         0021h             ; 
Sec2          equ         0022h             ;   
scetbit       equ         0023h             ;       spi
dat_ind       equ         0024h             ;       spi
adr_ind       equ         0025h             ;       spi
adr_tmp       equ         0026h             ;       spi
shet          equ         0027h             ;  
tmp_symb      equ         0028h             ;  
tmp_bit       equ         0029h             ;  
tmp_bit1      equ         002Ah             ;  

symbol        equ         002Bh             ;   

kol_matr      equ         002Ch             ;   
kol_symb      equ         002Dh             ;   


tmp_tab       equ         002Eh             ;   
nomer         equ         002Fh             ;   ascii 
temp          equ         0030h             ;  

FSR_symb      equ         0031h             ;      
FSR_viv       equ         0032h             ;     

data_symb     equ         0033h             ;     

data_viv      equ         003Ah             ;      

#DEFINE       din         PORTB,5           ;   
#DEFINE       cs          PORTB,6           ;  
#DEFINE       clk         PORTB,7           ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                            
Start         movlw       b'01000000'       ;    B
              movwf       PORTB             ;
              
              movlw       b'00000111'       ; 
              movwf       CMCON             ;

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00011111'       ;  \  B  
              movwf       TRISB             ;RB0-RB4  ,   
              bcf         STATUS,RP0        ; 0-                 
              
              movlw       .6                ;
              movwf       kol_symb          ;   

              movlw       .5                ;
              movwf       kol_matr          ;   

              call        init_lcd          ;    
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       

met_1         movlw       data_symb         ;      
              movwf       FSR               ; 
              movlw       ''               ; 1-  ''
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       ''               ; 2-  ''
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       ''               ; 3-  ''
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       ''               ; 4-  ''
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       ''               ; 5-  ''
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       ''               ; 6-  ''
              movwf       INDF              ;

              call        vivod             ;                       
              call        paus_2s           ;   2 
 
              movlw       data_symb         ;      
              movwf       FSR               ; 
              movlw       '+'               ; 1-  '+'
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       '2'               ; 2-  '2'
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       '3'               ; 3-  '3'
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       '.'               ; 4-  '.'
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       '9'               ; 5-  '9'
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       .176              ; 6-   , 
              movwf       INDF              ;            
                                            ;
              call        vivod             ;                       
              call        paus_2s           ;   2 

              movlw       data_symb         ;      
              movwf       FSR               ; 
              movlw       'R'               ; 1-  '+'
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       'a'               ; 2-  '2'
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       'd'               ; 3-  '3'
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       'i'               ; 4-  '.'
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       'o'               ; 5-  '9'
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       '!'               ; 6-  '9'
              movwf       INDF              ;

              call        vivod             ;                       
              call        paus_2s           ;   2              
              goto        met_1             ;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        

vivod         movlw       .1                ;  1-  ,    
              movwf       adr_ind           ;    

viv_3         movlw       data_viv          ;        
              movwf       FSR_viv           ;

              movlw       .8                ;       
              movwf       tmp_bit1          ;  

              movf        kol_symb,W        ; -   
              movwf       tmp_symb          ;   

              movlw       data_symb         ;      
              movwf       FSR               ; 
              decf        FSR,F             ;
viv_1         incf        FSR,F             ;
 
              movf        INDF,W            ;    nomer
              movwf       nomer             ;
              call        viv_symb          ;    

              decfsz      tmp_symb,F        ;  
              goto        viv_1             ;

              movlw       .8                ;        
              xorwf       tmp_bit1,W        ;
              btfsc       STATUS,Z          ;
              goto        viv_2             ;

              movf        FSR_viv,W         ;       
              movwf       FSR               ;

              rlf         INDF,F            ;         
              bcf         INDF,0            ;
              decfsz      tmp_bit1,F        ;
              goto        $-3               ;

viv_2         call        send              ;       
              incf        adr_ind,F         ;         
              movlw       .9                ;8- 
              xorwf       adr_ind,W         ;
              btfss       STATUS,Z          ;
              goto        viv_3             ;
              return                        ;    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      

viv_symb      movwf       nomer             ; 
              movlw       .32               ;
              subwf       nomer,W           ;
              btfss       STATUS,C          ;
              return                        ;   32:   

              movf        nomer,W           ;
              sublw       .82               ;
              btfss       STATUS,C          ;
              goto        viv_symb_1        ;   82:    viv_symb_1
              movlw       .32               ;   31   83:    tab_symb_1
              subwf       nomer,F           ;  32  ASCII  , 
              movlw       .1                ;  
              movwf       tmp_tab           ;   (1)   tmp_tab
              goto        symb_lcd          ;

viv_symb_1    movf        nomer,W           ;
              sublw       .126              ;
              btfss       STATUS,C          ;
              goto        viv_symb_2        ;   126:    viv_symb_2
              movlw       .83               ;   82   127:    tab_symb_2
              subwf       nomer,F           ;  83  ASCII  , 
              movlw       .2                ;  
              movwf       tmp_tab           ;   (2)   tmp_tab
              goto        symb_lcd          ;

viv_symb_2    movf        nomer,W           ;
              sublw       .191              ;
              btfss       STATUS,C          ;
              goto        viv_symb_3        ;   191:    viv_symb_3

              movlw       .176              ;  nomer     176
              xorwf       nomer,W           ;176 - ascii    , 
              btfss       STATUS,Z          ;
              return                        ;  :   
              movlw       .13               ;   176,   , 
              movwf       nomer             ;  .  
              movlw       .4                ;
              movwf       tmp_tab           ;   (4)   tmp_tab
              goto        symb_lcd          ;

viv_symb_3    movf        nomer,W           ;
              sublw       .242              ;
              btfss       STATUS,C          ;
              goto        viv_symb_4        ;   242:    viv_symb_4
              movlw       .192              ;   191   243:    tab_symb_3
              subwf       nomer,F           ;  192  ASCII  ,  
              movlw       .3                ;  
              movwf       tmp_tab           ;   (3)   tmp_tab
              goto        symb_lcd          ;

viv_symb_4    movlw       .243              ;   242:    tab_symb_4
              subwf       nomer,F           ;
              movlw       .4                ;
              movwf       tmp_tab           ;   (4)   tmp_tab
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    

symb_lcd      movf        nomer,W           ;     5
              addwf       nomer,F           ;
              addwf       nomer,F           ;
              addwf       nomer,F           ;
              addwf       nomer,F           ;
              movlw       .5                ;
              movwf       temp              ;    5  

              movf        FSR,W             ;      
              movwf       FSR_symb          ;        
              movf        FSR_viv,W         ;
              movwf       FSR               ;

symb_1        movlw       .1                ;    
              xorwf       tmp_tab,W         ;   
              btfss       STATUS,Z          ;
              goto        symb_m1           ;
              call        tab_symb_1        ;
              goto        symb_2            ;
symb_m1       movlw       .2                ;
              xorwf       tmp_tab,W         ;
              btfss       STATUS,Z          ;
              goto        symb_m2           ;
              call        tab_symb_2        ;
              goto        symb_2            ;
symb_m2       movlw       .3                ;
              xorwf       tmp_tab,W         ;
              btfss       STATUS,Z          ;
              goto        symb_m3           ;
              call        tab_symb_3        ;
              goto        symb_2            ;
symb_m3       call        tab_symb_4        ;
                       
symb_2        movwf       symbol            ;     symbol
              movf        adr_ind,W         ;       
              movwf       tmp_bit           ;     
              rlf         symbol,F          ;
              rrf         symbol,F          ;
              decfsz      tmp_bit,F         ;
              goto        $-2               ;
              
              rlf         INDF,F            ;      
              btfsc       symbol,0          ;    
              bsf         INDF,0            ;
              btfss       symbol,0          ;
              bcf         INDF,0            ;
              decfsz      tmp_bit1,F        ;
              goto        symb_3            ;
              movlw       .8                ;
              movwf       tmp_bit1          ;
              incf        FSR,F             ;

symb_3        incf        nomer,F           ;     
              decfsz      temp,F            ;   
              goto        symb_1            ;

              rlf         INDF,F            ; ,  
              bcf         INDF,0            ;
              decfsz      tmp_bit1,F        ;       
              goto        symb_4            ;
              movlw       .8                ;    ,   
              movwf       tmp_bit1          ;
              incf        FSR,F             ;
symb_4        movf        FSR,W             ;       
              movwf       FSR_viv           ;       
              movf        FSR_symb,W        ;
              movwf       FSR               ;
              return                        ;     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    MAX7219  

init_lcd      call        pauslcd           ;   2 
              movlw       0x0F              ;  
              movwf       adr_ind           ;
              movlw       0x00              ;
              call        send_dat          ;          

              movlw       0x0C              ;    
              movwf       adr_ind           ;
              movlw       0x01              ;
              call        send_dat          ;

              movlw       0x0A              ;   11/32
              movwf       adr_ind           ;
              movlw       0x05              ;
              call        send_dat          ;

              movlw       0x09              ;    
              movwf       adr_ind           ;
              movlw       0x00              ;
              call        send_dat          ;

              movlw       0x0B              ; 8 
              movwf       adr_ind           ;
              movlw       0x07              ;
              call        send_dat          ;
              return                        ;  

send_dat      movwf       dat_ind           ;    dat_ind
              movlw       data_viv          ;     
              movwf       FSR               ;
              movf        kol_matr,W        ;      shet 
              movwf       shet              ;
init_1        movf        dat_ind,W         ;      INDF
              movwf       INDF              ;
              incf        FSR,F             ;  FSR,     
              decfsz      shet,F            ;   
              goto        init_1            ;
              call        send              ;     
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     SPI   MAX7219   

send          bcf         cs                ;    CS
              movlw       data_viv          ;     
              movwf       FSR               ;
              movf        kol_matr,W        ;      shet 
              movwf       shet              ;

povtr2        movlw      .8                 ;    adr_ind  
              movwf      scetbit            ;
              movf       adr_ind,W          ;      
              movwf      adr_tmp            ;
povtor        bcf        clk                ;
              btfsc      adr_tmp,7          ;
              bsf        din                ;
              btfss      adr_tmp,7          ;
              bcf        din                ;
              bsf        clk                ;
              rlf        adr_tmp,F          ;
              decfsz     scetbit,F          ;
              goto       povtor             ;
             
              movlw      .8                 ;   INDF  
              movwf      scetbit            ;
povtr1        bcf        clk                ;
              btfsc      INDF,7             ;
              bsf        din                ;
              btfss      INDF,7             ;
              bcf        din                ;
              bsf        clk                ;
              rlf        INDF,F             ;
              decfsz     scetbit,F          ;
              goto       povtr1             ;
                                            ;
              incf       FSR,F              ;  FSR,     
              decfsz     shet,F             ;   
              goto       povtr2             ;
                                            ;
              bcf        clk                ; 
              bsf        cs                 ;  1    CS                 
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_1    movlw       high tab1         ;    
              movwf       PCLATH            ;,  0-9,   A-R
              movf        nomer,W           ;
              addlw       low tab1          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  
                                                  
tab1          dt 0x00, 0x00, 0x00, 0x00, 0x00; ()  ASCII  32
              dt 0x00, 0x00, 0x5F, 0x00, 0x00; !
              dt 0x00, 0x07, 0x00, 0x07, 0x00; "
              dt 0x14, 0x7F, 0x14, 0x7F, 0x14; #
              dt 0x24, 0x2A, 0x7F, 0x2A, 0x12; $
              dt 0x23, 0x13, 0x08, 0x64, 0x62; %
              dt 0x36, 0x49, 0x55, 0x22, 0x50; &
              dt 0x00, 0x05, 0x03, 0x00, 0x00; '
              dt 0x00, 0x1C, 0x22, 0x41, 0x00; (
              dt 0x00, 0x41, 0x22, 0x1C, 0x00; )
              dt 0x08, 0x2A, 0x1C, 0x2A, 0x08; *
              dt 0x08, 0x08, 0x3E, 0x08, 0x08; +
              dt 0x00, 0x50, 0x30, 0x00, 0x00; ,
              dt 0x08, 0x08, 0x08, 0x08, 0x08; -
              dt 0x00, 0x60, 0x60, 0x00, 0x00; .
              dt 0x20, 0x10, 0x08, 0x04, 0x02; /
              dt 0x3E, 0x51, 0x49, 0x45, 0x3E; 0
              dt 0x00, 0x42, 0x7F, 0x40, 0x00; 1
              dt 0x42, 0x61, 0x51, 0x49, 0x46; 2
              dt 0x21, 0x41, 0x45, 0x4B, 0x31; 3
              dt 0x18, 0x14, 0x12, 0x7F, 0x10; 4
              dt 0x27, 0x45, 0x45, 0x45, 0x39; 5
              dt 0x3C, 0x4A, 0x49, 0x49, 0x30; 6
              dt 0x01, 0x71, 0x09, 0x05, 0x03; 7
              dt 0x36, 0x49, 0x49, 0x49, 0x36; 8
              dt 0x06, 0x49, 0x49, 0x29, 0x1E; 9
              dt 0x00, 0x36, 0x36, 0x00, 0x00; :
              dt 0x00, 0x56, 0x36, 0x00, 0x00; ;
              dt 0x00, 0x08, 0x14, 0x22, 0x41; <
              dt 0x14, 0x14, 0x14, 0x14, 0x14; =
              dt 0x41, 0x22, 0x14, 0x08, 0x00; >
              dt 0x02, 0x01, 0x51, 0x09, 0x06; ?
              dt 0x32, 0x49, 0x79, 0x41, 0x3E; @
              dt 0x7E, 0x11, 0x11, 0x11, 0x7E; A
              dt 0x7F, 0x49, 0x49, 0x49, 0x36; B
              dt 0x3E, 0x41, 0x41, 0x41, 0x22; C
              dt 0x7F, 0x41, 0x41, 0x22, 0x1C; D
              dt 0x7F, 0x49, 0x49, 0x49, 0x41; E
              dt 0x7F, 0x09, 0x09, 0x01, 0x01; F
              dt 0x3E, 0x41, 0x41, 0x51, 0x32; G
              dt 0x7F, 0x08, 0x08, 0x08, 0x7F; H
              dt 0x00, 0x41, 0x7F, 0x41, 0x00; I
              dt 0x20, 0x40, 0x41, 0x3F, 0x01; J
              dt 0x7F, 0x08, 0x14, 0x22, 0x41; K
              dt 0x7F, 0x40, 0x40, 0x40, 0x40; L
              dt 0x7F, 0x02, 0x04, 0x02, 0x7F; M
              dt 0x7F, 0x04, 0x08, 0x10, 0x7F; N
              dt 0x3E, 0x41, 0x41, 0x41, 0x3E; O
              dt 0x7F, 0x09, 0x09, 0x09, 0x06; P
              dt 0x3E, 0x41, 0x51, 0x21, 0x5E; Q
              dt 0x7F, 0x09, 0x19, 0x29, 0x46; R    ASCII  82

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_2    movlw       high tab2         ;    
              movwf       PCLATH            ;,  S-Z, a-z
              movf        nomer,W           ;
              addlw       low tab2          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab2          dt 0x46, 0x49, 0x49, 0x49, 0x31; S    ASCII  83
              dt 0x01, 0x01, 0x7F, 0x01, 0x01; T
              dt 0x3F, 0x40, 0x40, 0x40, 0x3F; U
              dt 0x1F, 0x20, 0x40, 0x20, 0x1F; V
              dt 0x7F, 0x20, 0x18, 0x20, 0x7F; W
              dt 0x63, 0x14, 0x08, 0x14, 0x63; X
              dt 0x03, 0x04, 0x78, 0x04, 0x03; Y
              dt 0x61, 0x51, 0x49, 0x45, 0x43; Z
              dt 0x00, 0x00, 0x7F, 0x41, 0x41; [
              dt 0x02, 0x04, 0x08, 0x10, 0x20; \
              dt 0x41, 0x41, 0x7F, 0x00, 0x00; ]
              dt 0x04, 0x02, 0x01, 0x02, 0x04; ^
              dt 0x40, 0x40, 0x40, 0x40, 0x40; _
              dt 0x00, 0x01, 0x02, 0x04, 0x00; `
              dt 0x20, 0x54, 0x54, 0x54, 0x78; a
              dt 0x7F, 0x48, 0x44, 0x44, 0x38; b
              dt 0x38, 0x44, 0x44, 0x44, 0x20; c
              dt 0x38, 0x44, 0x44, 0x48, 0x7F; d
              dt 0x38, 0x54, 0x54, 0x54, 0x18; e
              dt 0x08, 0x7E, 0x09, 0x01, 0x02; f
              dt 0x08, 0x14, 0x54, 0x54, 0x3C; g
              dt 0x7F, 0x08, 0x04, 0x04, 0x78; h
              dt 0x00, 0x44, 0x7D, 0x40, 0x00; i
              dt 0x20, 0x40, 0x44, 0x3D, 0x00; j
              dt 0x00, 0x7F, 0x10, 0x28, 0x44; k
              dt 0x00, 0x41, 0x7F, 0x40, 0x00; l
              dt 0x7C, 0x04, 0x18, 0x04, 0x78; m
              dt 0x7C, 0x08, 0x04, 0x04, 0x78; n
              dt 0x38, 0x44, 0x44, 0x44, 0x38; o
              dt 0x7C, 0x14, 0x14, 0x14, 0x08; p
              dt 0x08, 0x14, 0x14, 0x18, 0x7C; q
              dt 0x7C, 0x08, 0x04, 0x04, 0x08; r
              dt 0x48, 0x54, 0x54, 0x54, 0x20; s
              dt 0x04, 0x3F, 0x44, 0x40, 0x20; t
              dt 0x3C, 0x40, 0x40, 0x20, 0x7C; u
              dt 0x1C, 0x20, 0x40, 0x20, 0x1C; v
              dt 0x3C, 0x40, 0x30, 0x40, 0x3C; w
              dt 0x44, 0x28, 0x10, 0x28, 0x44; x
              dt 0x0C, 0x50, 0x50, 0x50, 0x3C; y
              dt 0x44, 0x64, 0x54, 0x4C, 0x44; z
              dt 0x00, 0x08, 0x36, 0x41, 0x00; {
              dt 0x00, 0x00, 0x7F, 0x00, 0x00; |
              dt 0x00, 0x41, 0x36, 0x08, 0x00; }
              dt 0x10, 0x08, 0x08, 0x10, 0x08; ~    ASCII  126

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_3    movlw       high tab3         ;    
              movwf       PCLATH            ;  -, -
              movf        nomer,W           ;
              addlw       low tab3          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab3          dt 0x7E, 0x11, 0x11, 0x11, 0x7E; A    ASCII  192
              dt 0x7F, 0x49, 0x49, 0x49, 0x30; 
              dt 0x7F, 0x49, 0x49, 0x49, 0x36; B
              dt 0x7F, 0x01, 0x01, 0x01, 0x01; 
              dt 0x60, 0x3E, 0x21, 0x3F, 0x60; 
              dt 0x7F, 0x49, 0x49, 0x49, 0x41; 
              dt 0x67, 0x18, 0x7F, 0x18, 0x67; 
              dt 0x22, 0x41, 0x49, 0x49, 0x36; 3
              dt 0x7F, 0x10, 0x08, 0x04, 0x7F; 
              dt 0x7F, 0x10, 0x09, 0x04, 0x7F; 
              dt 0x7F, 0x08, 0x14, 0x22, 0x41; K
              dt 0x40, 0x3E, 0x01, 0x01, 0x7E; 
              dt 0x7F, 0x02, 0x04, 0x02, 0x7F; M
              dt 0x7F, 0x08, 0x08, 0x08, 0x7F; H
              dt 0x3E, 0x41, 0x41, 0x41, 0x3E; O
              dt 0x7F, 0x01, 0x01, 0x01, 0x7F; 
              dt 0x7F, 0x09, 0x09, 0x09, 0x06; P
              dt 0x3E, 0x41, 0x41, 0x41, 0x22; C
              dt 0x01, 0x01, 0x7F, 0x01, 0x01; T
              dt 0x27, 0x48, 0x48, 0x48, 0x3F; 
              dt 0x1E, 0x21, 0x7F, 0x21, 0x1E; 
              dt 0x63, 0x14, 0x08, 0x14, 0x63; X
              dt 0x3F, 0x20, 0x20, 0x3F, 0x40; 
              dt 0x1F, 0x10, 0x10, 0x10, 0x7F; 
              dt 0x7F, 0x40, 0x7F, 0x40, 0x7F; 
              dt 0x3F, 0x20, 0x3F, 0x20, 0x7F; 
              dt 0x01, 0x7F, 0x44, 0x44, 0x38; 
              dt 0x7F, 0x44, 0x7C, 0x00, 0x7F; 
              dt 0x7F, 0x44, 0x44, 0x44, 0x38; 
              dt 0x22, 0x41, 0x49, 0x49, 0x3E; 
              dt 0x7F, 0x08, 0x7F, 0x41, 0x7F; 
              dt 0x46, 0x29, 0x19, 0x09, 0x7F; 
              dt 0x20, 0x54, 0x54, 0x54, 0x78; a
              dt 0x3C, 0x4A, 0x4A, 0x4B, 0x30; 
              dt 0x7C, 0x54, 0x54, 0x58, 0x20; 
              dt 0x7C, 0x04, 0x04, 0x04, 0x04; 
              dt 0x60, 0x38, 0x24, 0x3C, 0x60; 
              dt 0x38, 0x54, 0x54, 0x54, 0x18; e
              dt 0x74, 0x08, 0x7C, 0x08, 0x74; 
              dt 0x28, 0x44, 0x54, 0x54, 0x28; 
              dt 0x7C, 0x20, 0x10, 0x08, 0x7C; 
              dt 0x7C, 0x21, 0x12, 0x09, 0x7C; 
              dt 0x7C, 0x10, 0x10, 0x28, 0x44; 
              dt 0x40, 0x78, 0x04, 0x04, 0x7C; 
              dt 0x7C, 0x08, 0x10, 0x08, 0x7C; 
              dt 0x7C, 0x10, 0x10, 0x10, 0x7C; 
              dt 0x38, 0x44, 0x44, 0x44, 0x38; o
              dt 0x7C, 0x04, 0x04, 0x04, 0x7C;    
              dt 0x7C, 0x14, 0x14, 0x14, 0x08; p   
              dt 0x38, 0x44, 0x44, 0x44, 0x28; c
              dt 0x04, 0x04, 0x7C, 0x04, 0x04;     ASCII  242

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_4    movlw       high tab4         ;    
              movwf       PCLATH            ;  -, ,
              movf        nomer,W           ;
              addlw       low tab4          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab4          dt 0x0C, 0x50, 0x50, 0x50, 0x3C; y    ASCII  243
              dt 0x18, 0x24, 0x7C, 0x24, 0x18; 
              dt 0x44, 0x28, 0x10, 0x28, 0x44; 
              dt 0x3C, 0x20, 0x20, 0x3C, 0x40; 
              dt 0x1C, 0x20, 0x20, 0x20, 0x7C; 
              dt 0x7C, 0x40, 0x7C, 0x40, 0x7C; 
              dt 0x3C, 0x20, 0x3C, 0x20, 0x7C; 
              dt 0x04, 0x7C, 0x48, 0x48, 0x30; 
              dt 0x7C, 0x48, 0x48, 0x30, 0x7C; 
              dt 0x7C, 0x48, 0x48, 0x48, 0x30; 
              dt 0x28, 0x44, 0x54, 0x54, 0x38; 
              dt 0x7C, 0x38, 0x44, 0x44, 0x38; 
              dt 0x48, 0x34, 0x14, 0x14, 0x7C;     ASCII  255

              dt 0x00, 0x06, 0x09, 0x09, 0x06; (  , ) ASCII  176

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pauslcd       movlw       .4                ;  2 
              movwf       Sec1              ;
p2            movlw       .166              ;
              movwf       Sec               ;
p1            decfsz      Sec,F             ;
              goto        p1                ;
              decfsz      Sec1,F            ;
              goto        p2                ;
              return                        ;  
                                            
paus_2s       movlw       .10               ;  2 
              movwf       Sec2              ;
p_3           movlw       .255              ;
              movwf       Sec1              ;
p_2           movlw       .255              ;
              movwf       Sec               ;
p_1           decfsz      Sec,F             ;
              goto        p_1               ;
              decfsz      Sec1,F            ;
              goto        p_2               ;
              decfsz      Sec2,F            ;
              goto        p_3               ;
              return                        ;  
                                            
              end                           ;  